;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;; ENTITY MANAGER
;;

.include "cpctelera.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE

max_entities == 10
entity_size  == 19

;;; TIPOS DE ENTIDADES 
_e_type_invalid ==  0x00 ;;
_e_type_render == 0x01 ;;Entity for render 0000 0001
_e_type_movable == 0x02 ;; Entity for move 0000 0010
_e_type_input == 0x04 ;; Entity for input  0000 0100
_e_type_ia == 0x08 ;; Entity for ia        0000 1000
_e_type_bullet == 0x10 ;; Entity for bullet 0001 0000
_e_type_collision == 0x20 ;; Entity for bullet 0010 0000
_e_type_animation == 0x40 ;; Entity for bullet 0100 0000 
_e_type_dead == 0x80 ;;Upper bit signals dead  entity 1000 0000 
_e_type_default == 0x7F ;;Default entity 0111 0000 
;; TIPO DE ENTIDADES 2
_e_type_princess == 0x01 ;; Entity for princess  0000 0001 
_e_type_enemy_small == 0x02;; Entity for enemy small 0000 0010
_e_type_bullet_enemy == 0x04;; Entity for bullet enemy 0000 0100
_e_type_ememy_shoter == 0x08;; Entity for enemy shoter 0000 1000
_e_type_arrow == 0x10 ;; Entity for arrow 0001 0000
_e_type_portal == 0x20;; Entity for portal 0001 0000
_e_type_obs_shoter == 0x40;; Entity for Obstaculo Shoter 0100 0000



_num_entities:: .db 0
_last_elem_ptr:: .dw _entity_array
_entity_array:: .ds max_entities*entity_size 
.db 0

_contador_vidas:: .db 00 , 00 , 00 ,00 

_muerta:   .db  0x00 , 0x00, 0x00 , 0x00 , 0x00,  0x00, 0x00
           .db  0x00, 0x00 
           .db  0x00, 0x00 , 0x000 , 0x00 , 0x00 
           .db  0x00, 0x00 
           .db  0x00 ,0x00  , 0x00


entity_man_getEntityArray_IX::
    ld      ix, #_entity_array
    ret

entity_man_getNumEntities_A::
    ld      a, (_num_entities)
    ret



;;INPUT  HL -> entidad 
;;RETURN IX -> puntero a la entidad
entity_man_create::


    call    entity_free_space 
    or      a
    jr      z, fin  ;; si da 0 acabo porque no hay espacio , sino sigo 

    ld      ix , (_last_elem_ptr)
    ld      de, (_last_elem_ptr)
    ld      bc, #entity_size
    ldir    

    ld      a, (_num_entities)
    inc     a
    ld      (_num_entities), a
    
    ld      hl, (_last_elem_ptr)
    ld      bc, #entity_size
    add     hl, bc 
    ld      (_last_elem_ptr), hl

fin:   
    ret



;;INPUT HL el puntero de la función  
;;      D el signature 
man_entity_forall::
    call    entity_man_getEntityArray_IX  ;; array de entidades  -> IX 
    
_desloop2:

    ld      a, 0(ix) ;; cargo tipo de entidad  0000 0011
    or      a ;; resto los tipos               0000 0011 
    ret     z ;;                              0000 0011

    push    de 
    push    hl
    call    #man_entity_forall_matching
    pop     hl 
    pop     de 

    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  
    jr      _desloop2


;;INPUT HL el puntero de la función  
;; en D el signature 
man_entity_forall_matching::
    ld      b,d  ; 0000 0001
    ld      (to_call), hl
   
    
    ld      a, 0(ix) ;0000 0001
    and     b       ;0000 0001 = 0000 0001
    sbc     a,b     ;0000 0001 - 0000 0001 =0000 0000
    ret     nz            
    
    to_call=.+1
    call    to_call
    ret


;; INPUT 
;; IX posición de puntero
entity_set4destroy::
    ld      0(ix),   #_e_type_dead ;;cargo en a el tipo_invalido
    ret


;;INPUT IX PUNTERO A DESTRUIR
entity_destroy:: 
        
    call  entity_man_getNumEntities_A ;; cuantas entidades me quedan a = 1
    
    ld      hl, (_last_elem_ptr)
    ld      bc, #-entity_size
    add     hl,bc
    ld      (_last_elem_ptr),hl
    
    dec     a
    ld      (_num_entities),a
    
    push    ix
    pop     de
    sbc     hl,de
    jr      z ,actualizar
    
    ld      hl,(_last_elem_ptr)
    ld      bc,#entity_size
    ldir 

actualizar:
    ld      hl, (_last_elem_ptr)
    ld      (hl) ,#0
    ret



entity_update:: 
    call    entity_man_getEntityArray_IX  ;; array de entidades  -> IX 
    call    entity_man_getNumEntities_A   ;; numero de entidades que hay en el array vivas  -> A 
    jr      _desloop
destruir:
    call    entity_destroy

_desloop:
    ld      a, 0(ix) ;; cargo tipo de entidad  
    or      a ;; si da 0, No hay más entidades 
    ret     z

    call    entity_dead 
    jr      z, _next ;; si es NO cero elimino y si no salto al siguiente 
    jr      destruir

_next:

    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  ;; 
    jr       _desloop



;; RETURN en A el valor de free_space
entity_free_space::
    ld      a, (_num_entities)
    ld      b,a
    ld      a, #max_entities ;; cargamos en a el max_entities 
    sbc     a, b ;; max_entities - _num_entities 
    ret 


eliminar_entidades::
    call    entity_man_getEntityArray_IX   

    ld      a , #max_entities
_eliminar_loop:
    or      a ;; si da 0, No hay más entidades 
    jr      z, salto_eliminar

    ld      hl, #_muerta
    push    ix 
    pop     de
    ld      bc, #entity_size
    ldir    

    dec     a 
    ld      bc,#entity_size ;; carga la cantidad de atributos que tiene entity  en bc 
    add     ix, bc  ;; 
    jr       _eliminar_loop

    

salto_eliminar:
    ld      a, #0
    ld      (_num_entities), a
    

    call    entity_man_getEntityArray_IX

    push    ix
    pop     hl

    ld      (_last_elem_ptr), hl
    
    ret



entity_dead::

    ld 		a, 0(ix)
	ld 		b, #_e_type_dead
	and 	a , b 

    ret 