;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------



;;
;; GENERATOR MANAGER
;;

.include "cpctelera.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;;             tipo,            x, y,   ancho, alto, vx, vy 
_player: .db  #_e_type_default ,2 , 170 , 6 , 14,  1, 1
;;          sprite
         .dw  #_spr_player_00   
;;           pvX,pvY        ,Salto , Dir  Disparo     
         .db 0x00 , 0xC0 ,   -1,   1  , 0 
;;          animacion 
         .dw 0,0
;;           contRender , nada ,    tipo 2 
         .db  0x00 , 0x00 , 00


_enemy: .db  #_e_type_default ,70, 70 , 6 , 12,  1, 0
        .dw  #_spr_enemy_0
        .db 0x00, 0xC0 , 1 , 1 , 0 
        .dw  0,0
        .db  0x00 , 0x00 ,  00
        
_enemy_shoter:  .db  #_e_type_default ,70, 70 , 6 , 12,  1, 0
                .dw  #_spr_enemy_shoter
                .db 0x00, 0xC0 , 1 , 0 , 0 
                .dw 0, 0
                .db  0x00 , 0x00 ,  00

_enemy_small:   .db  #_e_type_default ,70, 70 , 4 , 6,  1, 0
                .dw  #_spr_enemy_small
                .db 0x00, 0xC0 , 1 , 0 , 0 
                .dw 0 , 0
                .db  0x00 , 0x00 ,  00

_princess: .db  #_e_type_default ,2 , 20 , 6 , 14,  0, 0
           .dw  #_spr_princess
           .db 0x00, 0xC0 , 0 , 1 , 0 
           .db 0, 0 
           .db  0x00 ,0x00  , #_e_type_default


_bullet_heroe:  .db  #_e_type_default ,50 , 100 , 4 , 6,  2, 0
                .dw  #_spr_bullet_heroe
                .db 0x00, 0xC0 , 0, 1 , 0 
                .db 0, 0 
                .db 0x00 ,0x00  , 00

_bullet_enemy:  .db  #_e_type_default ,50 , 100 , 4 , 6,  2, 0
                .dw  #_spr_bullet_enemy
                .db 0x00, 0xC0 , 0, 1 , 0 
                .db 0, 0 
                .db 0x00 ,0x00  , 00

_flecha:    .db  #_e_type_default ,50 , 100 , 4 , 6,  0, 0
            .dw  #_spr_arrow_right
            .db 0x00, 0xC0 , 0, 0 , 0 
            .db 0, 0 
            .db 0x00 ,0x00  , 00

_portal:   .db  #_e_type_default ,15 , 20 , 6 , 14,  0, 0
           .dw  #_spr_portal 
           .db 0x00, 0xC0 , 0 , 1 , 0 
           .db 0, 0 
           .db  0x00 ,0x00  , #_e_type_default

_obstaculo: .db  #_e_type_default ,70, 70 , 6 , 12,  1, 0
            .dw  #_spr_arrow_right
            .db 0x00, 0xC0 , 1 , 1 , 0 
            .dw 0 , 0
            .db  0x00 , 0x00 ,  00
        


generator_Personaje::
    
    push bc 

    ld hl, #_player
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a, #_e_type_movable
    ld b ,#_e_type_render
    or b                       
    ld b, #_e_type_input
    or b   
    ld b, #_e_type_collision
    or b               
    ld b, #_e_type_animation
    or b                         
    ld 0(ix),a;;0110 0111

    ret 

generator_Enemigos::
    push bc 

    ld hl, #_enemy
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a, #_e_type_movable
    ld b ,#_e_type_render
    or b  
    ld b ,#_e_type_ia
    or b 
    ld b, #_e_type_collision
    or b          
    ld b, #_e_type_animation
    or b 
    ld 0(ix),a;0010 1011
    ret 

generator_Enemigos_Shoter::
    push bc 

    ld hl, #_enemy_shoter
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a, #_e_type_movable
    ld b ,#_e_type_render
    or b  
    ld b ,#_e_type_ia
    or b 
    ld b, #_e_type_collision
    or b          
    ld b, #_e_type_animation
    or b 
    ld 0(ix),a;0010 1011

    ld  a ,#_e_type_ememy_shoter
    ld 18(ix),a;0000 0001
    ret 

generator_Enemigos_Pequenyos::
    push bc 

    ld hl, #_enemy_small
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a, #_e_type_movable
    ld b ,#_e_type_render
    or b  
    ld b ,#_e_type_ia
    or b 
    ld b, #_e_type_collision
    or b 
    ld 0(ix),a;0010 1011

    ld  a ,#_e_type_enemy_small
    ld 18(ix),a;0000 0001
    ret 

generator_Obstaculo_Shoter::
    push bc 
    push de

    ld hl, #_obstaculo
    call entity_man_create

    pop de 
    pop bc 
    
    ld 1(ix), b
    ld 2(ix), c

    ld 12(ix),d 

    ld a, #_e_type_ia
    ld 0(ix),a;0000 0001

    ld  a ,#_e_type_obs_shoter
    ld 18(ix),a;0000 0001
    ret 



generator_Princesa::
    push bc 

    ld hl, #_princess
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a,#_e_type_render
    ld 0(ix),a;0000 0001

    ld  a ,#_e_type_princess
    ld 18(ix),a;0000 0001
    ret 

generator_Portal::
    push bc 

    ld hl, #_portal
    call entity_man_create

    pop bc 
    ld 1(ix), b
    ld 2(ix), c

    ld a,#_e_type_render
    ld 0(ix),a;0000 0001

    ld  a ,#_e_type_portal
    ld 18(ix),a;0000 0001

    ret 


;;INPUT
;;     -> a -> x 
;;     ->b -> y 
;;     ->c -> dir
generator_Balas::
    push af 
    push bc 
    ld hl, #_bullet_heroe
    call entity_man_create
    pop bc 
    pop af 
    
    ld 1(ix), a
    ld 2(ix), b
    ld 12(ix), c
    
    ld  a , c 
    cp  #1
    jr  z , positivo
    
    ld 5(ix), #-2

positivo: 
    ld a, #_e_type_bullet
    ld b ,#_e_type_render
    or b  
    ld b, #_e_type_collision
    or b          
    ld 0(ix),a;0011 0011
    ret 


generator_Balas_Enemigo::
    push af 
    push bc 
    push hl
    ld hl, #_bullet_enemy
    call entity_man_create
    pop hl 
    pop bc 
    pop af 
    
    ld 1(ix), a
    ld 2(ix), b
    ld 12(ix), c
    ld 14(ix), l
    ld 15(ix), h
    ld  a , c 
    cp  #1
    jr  z , positivo_bala_ene
    
    ld 5(ix), #-2
    jp salto_bala 

positivo_bala_ene:
    ld 5(ix), #2

salto_bala:
    ld a, #_e_type_bullet
    ld b ,#_e_type_render
    or b  
    ;ld b, #_e_type_collision
    ;or b          
    ld 0(ix),a;0011 0011

    ld a, #_e_type_bullet_enemy
    ld 18(ix), a
    ret 


generator_Flechas::
    push af 
    push bc 
    push hl
    ld hl, #_flecha
    call entity_man_create
    pop hl 
    pop bc 
    pop af 
    
    ld 1(ix), a
    ld 2(ix), b
    ld 12(ix), c
    ld 14(ix), l
    ld 15(ix), h
    
    ld  a , c 
    cp  #0
    jr  nz , no_der
    ld 5(ix), #2    
    jp salto_flecha

no_der:
    cp  #1
    jr  nz , no_izq
    ld 5(ix), #-2
    ld 7(ix), #<_spr_arrow_left
    ld 8(ix), #>_spr_arrow_left
    jp salto_flecha

no_izq:
    cp  #2
    jr  nz , no_up
    ld 6(ix), #-2
    ld 7(ix), #<_spr_arrow_up
    ld 8(ix), #>_spr_arrow_up
    jp salto_flecha
no_up:
    cp  #3
    jr  nz , salto_flecha
    ld 6(ix), #2
    ld 7(ix), #<_spr_arrow_down
    ld 8(ix), #>_spr_arrow_down

salto_flecha:
    ld a, #_e_type_bullet
    ld b ,#_e_type_render
    or b  
    ;ld b, #_e_type_collision
    ;or b          
    ld 0(ix),a;0011 0011

    ld a, #_e_type_arrow
    ld 18(ix), a
    ret 


