;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;; IA 
;;
.include "cpctelera.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE


;;INPUT IX posicion puntero entidad 
ia_update_one_entity::
    ld a, 1(ix) ;; x 
    ld b, #1
    add b ;; newx  
    ld c , #0x4A
    sbc a,c ;;
    jr z, toca_borde_der 
 
    ld a, 1(ix) ;; x 
    ld b, #-1 
    add b ;; newx 
    or a ;; comprobacion de que es cero
    jr z, toca_borde_izq

    jp salir

toca_borde_izq:
    ld 5(ix), #0x01
    jp salir 

 toca_borde_der:
    ld 5(ix), #0xFF

salir:

   call ia_enemy_shoter

    ret


ia_enemy_shoter::

    ld a, 18(ix) 
    ld b, #_e_type_ememy_shoter 
    and a, b 
    jr z, salir2

    ld b, #-20
    ld c, #20 
    call ia_disparo ;; izquierda 

    ld 12(ix), #1

    ld a, 13(ix)
    or a
    jr nz, salir2

    ld b, #10
    ld c, #-10 
    call ia_disparo ;; derecha 

    ld 12(ix), #-1

salir2:
    ret 

ia_update::
    ld a, #_e_type_movable 
    or a, #_e_type_ia
    ld d, a 
    ld hl, #ia_update_one_entity
    call man_entity_forall

     
    ld a, #_e_type_ia
    ld d, a 
    ld hl, #ia_shoter
    call man_entity_forall
    
    ret 


ia_shoter::
    ld a, 18(ix) 
    ld b, #_e_type_obs_shoter 
    and a, b 
    jr z, salir3

    call disparo_flecha
    
salir3:
    ret 


;;INPUT BC = POSICION A COLISIONAR
ia_disparo:: 
    push    ix 
    
    call entity_man_getEntityArray_IX
    push    ix 
    pop     iy 
    
    pop     ix 

;;IF COMPROBACION COLISION 
    ld      a, 1(ix)
    add     b
    add     3(ix)
    sub     1(iy)
    jr      c, no_disparo 

    ld      a, 1(iy)
    add     c
    add     3(iy)
    sub     1(ix)
    jr      c, no_disparo 

    ld      a, 2(ix)
    add     4(ix)
    sub     2(iy)
    jr      c, no_disparo 

    ld      a, 2(iy)
    add     4(iy)
    sub     2(ix)
    jr      c, no_disparo 


    call disparo_enemy
    
no_disparo:
    ret 

disparo_enemy::
    
    ld a, 13(ix)
    or a
    jr nz, no_disparo2

    ;Actualizar Disparo 
    ld 13(ix), #1

    ld a, 1(ix)
    ld b, 2(ix)
    ld c, 12(ix)
    push ix 
    pop  hl
    push ix 
    call generator_Balas_Enemigo
    pop ix 
    
no_disparo2:
    ret 


disparo_flecha::
    
    ld a, 13(ix)
    or a
    jr nz, no_disparo3

    ;Actualizar Disparo 
    ld 13(ix), #1

    ld a, 1(ix)
    ld b, 2(ix)
    ld c, 12(ix)
    push ix 
    pop  hl
    push ix 
    call generator_Flechas
    pop ix 
    
no_disparo3:
    ret 