;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;;  MENU
;;

.include "cpctelera.h.s"
.include "screens/screenmenu_z.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
.area _CODE

;; Init del menu
man_menu_init::

    ld hl, #_screenmenu_z_end
    ld de, #0xFFFF
    ;;DESCOMPRIME Y MUESTRA POR PANTALLA 
    call cpct_zx7b_decrunch_s_asm ; af , bc , de , hl 

    ret

;; Update del menu
man_menu_update::
loop_menu:
    ld   hl, #Key_1
    call cpct_isKeyPressed_asm
    jr   z, no_play
    
    call    music_next_song
    call    cargador_nivel

no_play:    
    ld   hl, #Key_2
    call cpct_isKeyPressed_asm
    jr   z, no_controls

    call    man_menu_controls
    call    wait_esc 

no_controls:
    ld   hl, #Key_3
    call cpct_isKeyPressed_asm
    jr    z, loop_menu

    call    man_menu_creditos
    call    wait_esc 

    ret 


man_menu_controls::

    ld hl, #_screencontrols_z_end
    ld de, #0xFFFF
    ;;DESCOMPRIME Y MUESTRA POR PANTALLA 
    call cpct_zx7b_decrunch_s_asm ; af , bc , de , hl 

    ret

man_menu_creditos::

    ld hl, #_screencredits_z_end
    ld de, #0xFFFF
    ;;DESCOMPRIME Y MUESTRA POR PANTALLA 
    call cpct_zx7b_decrunch_s_asm ; af , bc , de , hl 

    ret


wait_esc::

loop_wait:
    ld   hl, #Key_Esc
    call cpct_isKeyPressed_asm
    jr   z, loop_wait
    
    call man_menu_init
    call man_menu_update

    ret 