;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


.module cpct_strings

.include "strings/strings.s"


my_drawStringMO::

   jr    firstChar                  ;; [3] Jump to first char (Saves 1 jr back every iteration)

nextChar:
   ;; Draw next character
   push  hl                         ;; [4] Save HL
   call  my_drawChar_Inner  ;; [5 + 824/832] Draws the next character
   pop   hl                         ;; [3] Recover HL 

   ;; Increment Pointers
   ld    de, #4                     ;; [3] /
   add   hl, de                     ;; [3] | HL += 4 (point to next position in video memory, 8 pixels to the right)
   inc   iy                         ;; [3] IX += 1 (point to next character in the string)

firstChar:
   ld     a, (iy)                   ;; [5] A = next character from the string
   or     a                         ;; [1] Check if A = 0
   jr    nz, nextChar               ;; [2/3] if A != 0, A is next character, draw it, else end

endstring:

   ret
;; IX/IY Restore and Return provided by bindings