;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------



;;
;; PHYSICS SYSTEM
;;
.include "cpctelera.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE

IndiceJumpTable:
    .db  0

Jumptable: 
    .db  #-7, #-7 , #-7 
    .db  #-7, #0 , #0 
   
    .db  #0x80


anterior: .db 0 
actual:   .db 0

;;INPUT IX posicion puntero entidad 
physics_check_keyboard::
    ld      5(ix), #0 ;; vx 
   
    ld      hl, #Key_O
    call    cpct_isKeyPressed_asm
    jr      z, o_not_pressed 

o_pressed:

    ld      a, 1(ix) ;; x 
    ld      b, #-1 
    add     b ;; newx 
    or      a ;; comprobacion de que es cero
    jr      z, o_not_pressed 
    
    ld      5(ix), b
    ld      12(ix), #-1

    jp      joy_left_not_pressed

o_not_pressed:

joy_left_not_pressed:
    ld      hl, #Key_P
    call    cpct_isKeyPressed_asm ;; 0 o 1 
    jr      z, p_not_pressed 

p_pressed:
    ld      a, 1(ix) ;; x 
    ld      b, #1
    add     b ;; newx  
    ld      c , #0x4A
    sbc     a,c ;;
    jr      z, p_not_pressed 
    ld      5(ix), #1
    ld      12(ix), #1
   
    jp      joy_right_not_pressed

p_not_pressed:
   

joy_right_not_pressed:
    ld      hl, #Key_Q
    call    cpct_isKeyPressed_asm ;; 1
    jr      z, q_not_pressed 

 
q_pressed:
    ;;-1 = ESTAR SALTANDO | 0 = NO SALTANDO
    ;Comprobar Salto 
    ld      a, 11(ix)
    cp      #-1 
    jr      z, q_not_pressed 

    ;;Valor actual del Salto 
    ld      hl, #Jumptable
    ld      c, a 
    ld      b,#0
    add     hl , bc 
    
    ;;Comprobamos si se ha terminado el salto
    ld      a,(hl)
    cp      #0x80
    jr      z, fin_salto
    
    ;; Cargamos el valor de jumptable en vy 
    ld      6(ix),a

    ;;Incrementar Indice Jumptable 
    ld      a, 11(ix)
    inc     a
    ld      11(ix), a

    jp      joy_up_not_pressed

fin_salto:
    ;Actualizar valor de Salto 
    ld      a, #-1 
    ld      11(ix), a 

q_not_pressed:


joy_up_not_pressed:
    ld      hl, #Key_Space
    call    cpct_isKeyPressed_asm ;; 0 o 1 
    jr      z, space_not_pressed 

    
space_pressed:
    ;Comprobar Disparo 
    ld      a, 13(ix)
    or      a
    jr      nz, space_not_pressed

    ;Actualizar Disparo 
    ld      13(ix), #1

    ld      a, 1(ix)
    ld      b, 2(ix)
    ld      c, 12(ix)
    push ix 
    call generator_Balas
    pop ix 


    jp      salir


space_not_pressed:
    

salir:  
    ret

;; INPUT 
;; IX posición de puntero
physics_update_one_entity::
   
    ld      b, #_e_type_input ; 0100
    ld      a, 0(ix)          ; 0011
    and     b                ; 0000 = 0000
    sbc     a,b              ; 0000 - 0100 = 00 - 04 = FB -> 1111 1011
    jr      nz,  saltar      

    call    physics_check_keyboard

saltar:
    ;; ACTUALIZAR X
    ld      h, 5(ix)
    ld      a, 1(ix)
    add     h
    ld      1(ix), a
    
    ;;ACTUALIZAR Y
    ld      a, 2(ix) ;; y 
    ld      h, 6(ix) ;; vy 
    add     h ;; y + vy 
    ld      h,a  ;; h -> suma 

    ld      a ,2(ix);; y antes de actulizar
    ld      2(ix), h ;; y = suma
    
    ld      6(ix), #7 ;; vy o gravedad

    ret 


physics_update::
    ld      hl, #physics_update_one_entity
    ld      d, #_e_type_movable
    call    man_entity_forall
    ret

