;;-----------------------------LICENSE NOTICE------------------------------------
;;   AUTHORS OF THE GAME:
;;
;; - Andres David Rojas Carrillo  <http://andresrojas.tk>
;; - Mario Villora Pico
;; - Roberto Ruiz Ucles
;;
;;    This file is part of THEHERO

;;   THEHERO is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;   (at your option) any later version.

;;    THEHERO is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.

;;    You should have received a copy of the GNU General Public License
;;    along with Foobar.  If not, see <https://www.gnu.org/licenses/>.
;;-------------------------------------------------------------------------------


;;
;; RENDER SYSTEM
;;
.include "cpctelera.h.s"
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE


rendersys_init::
	halt
	ld		c, #0
	call	cpct_setVideoMode_asm ;; PUEDE CAMBIAR INTERRUPCIONES 

    ;CAMBIAR BORDE A NEGRO 
	ld		hl, #0x1410
	call	cpct_setPALColour_asm
;
	ld  	de, #16
	ld		hl, #_g_palette
	call	cpct_setPalette_asm
	ret 


render_xor::

	call 	entity_dead
	jr 		nz , salir_xor
	;;Calculate a video memory location 
	call 	render_entity 

salir_xor:
	ret 

render_entity::
	
	ld 		e, 9(ix)
	ld 		d, 10(ix)
	ld 		l ,7(ix) ;; Sprite
	ld		h, 8(ix) ;; Sprite 
    ld      b, 3(ix) ;;Width
    ld      c, 4(ix) ;;Height
	call    cpct_drawSpriteBlended_asm ;; necesita de(getScreenPtr) , b , c ,  hl 
	ret 

;;INPUT:
;;  IX: Pointer to entity to render
render_one_entity::
	
	call	entity_dead
	jr 		nz , salir

	ld 		a, 16(ix)
	cp 		#0 
	jr 		z, salto_sumo 
	call 	render_xor

salto_sumo: 
	ld 16(ix), #1 

	;;Calculate a video memory location 
    ld      de, #0xC000
    ld      c, 1(ix) ;;x
    ld      b, 2(ix) ;;y
    call    cpct_getScreenPtr_asm ;; esto devuelve el valor en hl 

	ld		9(ix), 	l
	ld 		10(ix),	h

	call 	render_entity
salir:
	ret 

rendersys_update::
	ld 		hl, #render_one_entity
    ld 		d, #_e_type_render
    call 	man_entity_forall
	ret 



render_death_entity::
	call 	entity_dead
   	jr 		z, salir2

	call 	render_entity

salir2:
	ret


render_death_update::
	ld 		hl, #render_death_entity
    ld 		d, #_e_type_dead
    call 	man_entity_forall
	ret 
	

rendersys_pause_update::
	ld 		hl, #render_xor
    ld 		d, #_e_type_render
    call 	man_entity_forall
	ret 



;;320 de ancho 320/8 = 40 / 2  = 20
;;200 de alto 200 / 8 = 25
render_tilemap_0::
	push de

	ld bc, #0x1905
	ld de, #0x14
	ld hl, #_tiles_00
	call cpct_etm_setDrawTilemap4x8_ag_asm 

	pop de 
	ld hl, #0xC000
	call cpct_etm_drawTilemap4x8_ag_asm 

	ret 



;;320 de ancho 320/8 = 40 / 2  = 20
;;200 de alto 200 / 8 = 25
render_tilemap_1::
	push de

	ld bc, #0x1905
	ld de, #0x14
	ld hl, #_tiles_00 ;; imagenes
	call cpct_etm_setDrawTilemap4x8_ag_asm 

	pop de  ;; tilemap 

	ex de , hl 
	ld bc , #0x05 
	add hl , bc 
	ex de, hl 
	
	ld hl, #0xC014
	call cpct_etm_drawTilemap4x8_ag_asm 

	ret 


render_tilemap_2::
	push de

	ld bc, #0x1905
	ld de, #0x14
	ld hl, #_tiles_00 ;; imagenes
	call cpct_etm_setDrawTilemap4x8_ag_asm 

	pop de  ;; tilemap 

	ex de , hl 
	ld bc , #0x0A 
	add hl , bc 
	ex de, hl 
	
	ld hl, #0xC028
	call cpct_etm_drawTilemap4x8_ag_asm 

	ret 

render_tilemap_3::
	push de

	ld bc, #0x1905
	ld de, #0x14
	ld hl, #_tiles_00 ;; imagenes
	call cpct_etm_setDrawTilemap4x8_ag_asm 

	pop de  ;; tilemap 

	ex de , hl 
	ld bc , #0x0F 
	add hl , bc 
	ex de, hl 
	
	ld hl, #0xC03C
	call cpct_etm_drawTilemap4x8_ag_asm 

	ret 
